import { CHAIN_ID_BSC, CHAIN_ID_ETH, CHAIN_ID_SOLANA, CHAIN_ID_TERRA, } from "./consts";
import { humanAddress } from "../terra";
import { PublicKey } from "@solana/web3.js";
import { hexValue, hexZeroPad, stripZeros } from "ethers/lib/utils";
export var isHexNativeTerra = function (h) { return h.startsWith("01"); };
export var nativeTerraHexToDenom = function (h) {
    return Buffer.from(stripZeros(hexToUint8Array(h.substr(2)))).toString("ascii");
};
export var uint8ArrayToHex = function (a) {
    return Buffer.from(a).toString("hex");
};
export var hexToUint8Array = function (h) {
    return new Uint8Array(Buffer.from(h, "hex"));
};
export var hexToNativeString = function (h, c) {
    try {
        return !h
            ? undefined
            : c === CHAIN_ID_SOLANA
                ? new PublicKey(hexToUint8Array(h)).toString()
                : c === CHAIN_ID_ETH || c === CHAIN_ID_BSC
                    ? hexZeroPad(hexValue(hexToUint8Array(h)), 20)
                    : c === CHAIN_ID_TERRA
                        ? isHexNativeTerra(h)
                            ? nativeTerraHexToDenom(h)
                            : humanAddress(hexToUint8Array(h.substr(24))) // terra expects 20 bytes, not 32
                        : h;
    }
    catch (e) { }
    return undefined;
};
